package messagedigest;

import java.security.*;

public class Digester {

public Digester()
{
}


public static DigestClass encode(String s, String digestMethod)
                                            throws NoSuchAlgorithmException
{
   //Creates a mesage digest from s and returns a DigestClass object

   //Get a message digest instance
   MessageDigest mdest = MessageDigest.getInstance(digestMethod);
   //Get sent string
   byte[] holder = s.getBytes();
   //create the message digest
   mdest.update(holder);
   return new DigestClass(s,mdest);
}

public static boolean unTampered(DigestClass dc, String digestMethod)
                                                throws NoSuchAlgorithmException
{
   //Create a message digest instance using a particular digest method
   MessageDigest mdig = MessageDigest.getInstance(digestMethod);
   //Calculate the message digest and add it to mdig
   mdig.update((dc.getMessage()).getBytes());
   //Return true if calculated message digest matches sent message digest
   //The method digest computes the digest and places it in a byte array
   //while digest retrieves the digest that was sent
   return
      MessageDigest.isEqual(mdig.digest(), dc.getMessageDigest().digest());
}


public static void main(String[] args)throws NoSuchAlgorithmException
{
   //Message to be sent
   String message = "Hello there I am Darrel Ince";
   //Create the digest using the SHA method
   DigestClass dc = encode(message, "SHA");
   //Check if has not been tampered with
   if (unTampered(dc, "SHA"))
      System.out.println("Message was untampered");
}

}
