package cachedclient;

import java.awt.*;

public class CachedClient extends Frame
{

public CachedClient()
{
   SymWindow aSymWindow = new SymWindow();
   this.addWindowListener(aSymWindow);
   SymAction lSymAction = new SymAction();
   addButton.addActionListener(lSymAction);
   searchButton.addActionListener(lSymAction);
   quitButton.addActionListener(lSymAction);
   setLayout(null);
   setSize(405,305);
   setVisible(false);
   addButton.setLabel("Add");
   add(addButton);
   addButton.setBackground(java.awt.Color.lightGray);
   addButton.setBounds(36,60,61,26);
   searchButton.setLabel("Search");
   add(searchButton);
   searchButton.setBackground(java.awt.Color.lightGray);
   searchButton.setBounds(36,96,61,26);
   add(addField);
   addField.setBounds(132,60,152,24);
   add(searchField);
   searchField.setBounds(132,96,152,24);
   add(messageField);
   messageField.setBounds(36,180,285,30);
   messageLabel.setText("Messages");
   add(messageLabel);
   messageLabel.setBounds(36,156,60,24);
   quitButton.setLabel("Quit");
   add(quitButton);
   quitButton.setBackground(java.awt.Color.lightGray);
   quitButton.setBounds(36,240,61,26);
   setTitle("Exercise 14.1");
   cache = new FixedQueue(5);
}

public CachedClient(String title)
{
   this();
   setTitle(title);
}

static public void main(String args[])
{
   try
   {
      //Create a new instance of our application's frame, and make it visible.
      (new CachedClient()).setVisible(true);
   }
   catch (Throwable t)
   {
      System.err.println(t);
      t.printStackTrace();
      //Ensure the application exits with an error condition.
      System.exit(1);
   }
}

public void addNotify()
{
   // Record the size of the window prior to calling parents addNotify.
   Dimension d = getSize();
   super.addNotify();
   if (fComponentsAdjusted)
      return;
   // Adjust components according to the insets
   setSize(getInsets().left + getInsets().right + d.width,
           getInsets().top + getInsets().bottom + d.height);
   Component components[] = getComponents();
   for (int i = 0; i < components.length; i++)
   {
      Point p = components[i].getLocation();
      p.translate(getInsets().left, getInsets().top);
      components[i].setLocation(p);
   }
   fComponentsAdjusted = true;
}

// Used for addNotify check.
boolean fComponentsAdjusted = false;

java.awt.Button addButton = new java.awt.Button();
java.awt.Button searchButton = new java.awt.Button();
java.awt.TextField addField = new java.awt.TextField();
java.awt.TextField searchField = new java.awt.TextField();
java.awt.TextField messageField = new java.awt.TextField();
java.awt.Label messageLabel = new java.awt.Label();
java.awt.Button quitButton = new java.awt.Button();
public FixedQueue cache;

class SymWindow extends java.awt.event.WindowAdapter
{
   public void windowClosing(java.awt.event.WindowEvent event)
   {
      Object object = event.getSource();
      if (object == CachedClient.this)
         Frame1_WindowClosing(event);
   }
}

void Frame1_WindowClosing(java.awt.event.WindowEvent event)
{
   Frame1_WindowClosing_Interaction1(event);
}


void Frame1_WindowClosing_Interaction1(java.awt.event.WindowEvent event)
{
   try
   {
     System.exit(0);
   }
   catch (Exception e) {}
}


class SymAction implements java.awt.event.ActionListener
{
public void actionPerformed(java.awt.event.ActionEvent event)
{
   Object object = event.getSource();
   if (object == addButton)
      addButton_ActionPerformed(event);
   else if (object == searchButton)
      searchButton_ActionPerformed(event);
   else if (object == quitButton)
      quitButton_ActionPerformed(event);
}

}


void addButton_ActionPerformed(java.awt.event.ActionEvent event)
{
   //Add button clicked
   String addedText = addField.getText();
   cache.add(new Data(addedText, new Object()));
   messageField.setText(addedText + " added");
}

void searchButton_ActionPerformed(java.awt.event.ActionEvent event)
{
//Search button clicked
String searchedForText = searchField.getText();
if(cache.find(searchedForText))
   messageField.setText(searchedForText + " found");
else
   messageField.setText(searchedForText + " not found");
}

void quitButton_ActionPerformed(java.awt.event.ActionEvent event)
{
System.exit(0);
}

}

