package cachedclient;

//A queue implemented using a linked list

public class FixedQueue {

//size is the maximum size of the queue,
//count is the number of items in the queue

private int size, count;

//head points at the first element in the queue and
//tail points at the last. Each item in the queue
//is an Element

private Element head, tail;

public FixedQueue(int size)
{
   this.size = size;
   count=0;
   head = tail = null;
}

public void add(Data data)
{
   //Adds an item to the queue
   Element toBeAdded = new Element(data, null);
   if(count == 0)
   {
      head = tail = toBeAdded;
      count =1;
      return;
   }
   tail.setNext(toBeAdded);
   tail=toBeAdded;
   if(count == size)
      head = head.getNext();
   else
      count++;
}

//Finds whether a particular string is cotnained in the queue
//Carries out a linear search of the linked list
public boolean find(String toBeFound)
{
   if(count==0)
      //Nothing in the list
      return false;
   Element pointer = head;
   String identifier = pointer.getData().getId();
   Element nextElement = pointer.getNext();
   //Search sequentially until either end of list
   //encountered or item found
   while((!identifier.equals(toBeFound)) && nextElement !=null)
   {
      pointer = pointer.getNext();
      identifier = pointer.getData().getId();
      nextElement = pointer.getNext();
   }
   return (identifier.equals(toBeFound));
}

}