package botrunner;

import java.io.*;
import java.net.*;
import java.util.*;
import botclient.Bot;

public class Server {

private FileReader fr;
private Vector userAccesses;

  public Server(Vector userAccesses)
  {
     try
     {
        System.out.println("...Setting up socket");
        //Set up connections
        ServerSocket ss = new ServerSocket(1099);
        Socket s = ss.accept();
        System.out.println("...Setting up streams");
        //Set up object streams to receive and then send back bot
        InputStream is = s.getInputStream();
        OutputStream os = s.getOutputStream();
        //Object stream set up
        ObjectOutputStream oStream = new ObjectOutputStream(os);
        ObjectInputStream iStream = new ObjectInputStream(is);
        System.out.println("...Receiving bot");
        //Read bot
        Bot sentBot = (Bot) iStream.readObject();
        System.out.println("...Bot received");
        String queryString = sentBot.getQuery();
        //Execute query
        int answer = sentBot.findUserAccesses(userAccesses, queryString);
        //Update bot with the answer to the query
        sentBot.setAnswerToQuery(answer);
        System.out.println("...Sending bot back");
        //Send the bot back with the answer
        oStream.writeObject(sentBot);
        System.out.println("...Closing");
        //Close everything down
        oStream.close();
        iStream.close();
        is.close();
        os.close();
        s.close();
        ss.close();
     }
     catch(Exception e){System.out.println("Problem setting up server "+e);};
  }


}