package linkchecking;

import org.xml.sax.*;
import java.io.*;

public class ReportProducer extends HandlerBase{

private PrintWriter pw;     //Writes to the XML file which contains the report
                            //on the dead links
public ReportProducer()
{
   try
   {
      //Delete existing XML report file
      new File("report.txt").delete();
      //Create a print writer that will write to the report file
      pw = new PrintWriter
            (new FileOutputStream("report.txt", true));
   }
   catch(Exception e)
      {System.out.println("Problem setting up report file");}
}

public static void main(String[] args)
{
   try
   {
   //***************************************************************************
   // Ignore the code to the next line of asterisks: it  sets up the XML parser
   // and processes the XML contained in the file links.txt
   Class loadedClass = Class.forName("com.ibm.xml.parser.SAXDriver");
   Parser xParser = (Parser)loadedClass.newInstance();
   ReportProducer rp = new ReportProducer();
   xParser.setDocumentHandler(rp);
   xParser.setErrorHandler(rp);
   xParser.parse("links.txt");
   }
   catch(Exception e)
      {System.out.println("Problem starting XML processor "+e.getMessage());}
}

//******************************************************************************

public void error(SAXParseException se)
{
   //Executed when a serious error occurs in processing the XML source
   System.out.println("Error: Problem with XML "+se.getMessage());
}

public void warning(SAXParseException se)
{
   //Executed when a minor problem occurs when processing the XML source
   System.out.println("Warning: Problem with XML "+se.getMessage());
}

public void startDocument() throws SAXException
{
   //Executed when the XML document is executed
   System.out.println("Document started");
}

public void startElement(String elementName, AttributeList al) throws SAXException
{
   //Executed when a start element such as <EMAIL> is encountered
   //elementName contains the name of the element and al contains
   //a list of the attributes

   //Just prints the type of data encountered
   if(elementName.equals("LINKBREAK"))
      pw.println();
   if(elementName.equals("URL"))
      pw.print("URL =");
   if(elementName.equals("EMAIL"))
      pw.print("Email address =");
   if(elementName.equals("DESCRIPTION"))
      pw.print("Description of link =");

}

public void endElement(String elementName) throws SAXException
{
   //Executed when the end element is encountered, for example </EMAIL>
   //No code for this
}

public void endDocument() throws SAXException
{
   //Executed when the XML source has been completely processed
   pw.close();
   System.out.println("Document finished");
}

public void characters(char[] chars, int start, int length)throws SAXException
{
   //Executed when a string is encountered,
   //for example the text description of a link
   pw.println(" "+new String(chars, start, length));
}

}