package checksoftware;

import java.net.*;
import java.util.Date;
import java.io.IOException;

public class URLTest
{

// Static constants

// Domain not recognised
public static int siteNotFound = 0;

// Domain recognised, resource not found
public static  int resourceNotFound = 1;

// Everything OK
public static int resourceFound = 2;

//Instance variables

private URL urlString;
private URLConnection connect;

public URLTest(String urlVal)throws MalformedURLException
{
   urlString = new URL(urlVal);
}

public int testURL()
{
   int resCode =0;
   HttpURLConnection ht= null;
   try
   {
      connect = urlString.openConnection();
      ht = (HttpURLConnection) connect;
      resCode = ht.getResponseCode();
   }
   catch (IOException e)
   {
      // Domain not found -- takes time to get here
      return siteNotFound;
   }
   if(resCode == HttpURLConnection.HTTP_OK)
      //Server has responded positively
      return resourceFound;
   else
      // Server cannot find resource
      return resourceNotFound;
}

public String getFile()
{
   // Return with the file name of the URL
   return urlString.getFile();
}

public String getProtocol()
{
   // Returng with the protocol of the URL, for example http
   return urlString.getProtocol();
}

public String getHost()
{
   // Return with the host, for example www.open.ac
   return urlString.getHost();
}

public int getPort()
{
   // Return with the port, for example 80
   return urlString.getPort();
}


public String getLastModified()
{
   // Return with the date that the resource
   // was last modified
   long lastMod = connect.getLastModified();
   return new Date(lastMod)+"";
}

}
