package salesserver;

import java.awt.Frame;
import java.sql.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

//Business object for collection of sales, identical to that found
//in Exercise 17.5 apart from the fact that getAllSales returns a
//Vector object rather than an enumeration. This is because enumerations
//cannot be serialised

public class SaleCollectionImpl extends UnicastRemoteObject
                                     implements SaleCollection{

private Connection cn;

public SaleCollectionImpl(String dbName)throws RemoteException
{
   //Sets up sales database
   try
   {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      cn =
         DriverManager.getConnection("jdbc:odbc:"+dbName, "Darrel", "");
   }
   catch(Exception e)
      {System.out.println("Problem setting up database"+e);};
}

public Sale findSale(String emailAddress)throws RemoteException
{
   //Returns the sale made to the user identified by emailAddress
   Statement query;
   ResultSet rs;
   Sale saleRetrieved=null;
   try
   {
      query = cn.createStatement();
      String queryString =
              "Select * from SalesTable where EmailAddress= '"+emailAddress+"'";
      rs = query.executeQuery(queryString);
      rs.next();
      saleRetrieved = new Sale
                          (rs.getString(1), rs.getString(2),rs.getString(3));
    }
    catch(Exception e)
       {System.out.println("Trouble accessing sales database");}
  return saleRetrieved;
  }

  public void insertSale(Sale saleMade)throws RemoteException
  {
     //Inserts saleMade into collection of sales
     String query = "Insert into SalesTable (EmailAddress,SoftwareVersion,PIN"
                    +") values"+"('"+saleMade.getEmailAdress()+"','"
                    +saleMade.getSoftwareVersion()+"','"+ saleMade.getPinNumber()
                    +"')";
     try
     {
        Statement qStatement = cn.createStatement();
        qStatement.executeUpdate(query);
     }
     catch(Exception e)
      {System.out.println("Problem inserting link"+e);}
  }

  public Vector getAllSales()throws RemoteException
  {
     //Returns an enumeration to sales retrieved by a query
     //The query retrieves products over a certain price
     System.out.println("Executed");
     Vector extractedSales=new Vector ();
     ResultSet rs;
     Statement query;
     try
     {
        //Execute query
        query = cn.createStatement();
        String queryString =
              "Select * from SalesTable";
        rs = query.executeQuery(queryString);
        //Loop around result set creating sales and placing
        //them in a vector
        while(rs.next())
        {
          Sale extractedSale = new Sale
                 (rs.getString(1), rs.getString(2), rs.getString(3));
          extractedSales.add(extractedSale);
        }
        rs.close();
     }
     catch (Exception e){System.out.println("Problem with query "+e);}
     return extractedSales;
  }

public void close()throws RemoteException
{
   //Closes down the collection of sales and shuts down corresponding database
   try
   {
     cn.close();
   }
   catch(Exception e)
      {System.out.println("Problem shutting down sales database");}
}

public static void main(String[] args)
{
   //Load in the security manager
   System.setSecurityManager(new RMISecurityManager());
   try
   {
      //Set up the remote object
      SaleCollectionImpl sc = new SaleCollectionImpl("SoftwareSales");
      System.out.println("Database set up...");
      //Give the name "Sales" to the object
      Naming.rebind("Sales", sc);
      System.out.println("Sales collection ready...");
   }
   catch(Exception e){System.out.println("Problem with server"+e);}
}

}