package linkmaintenance;

import java.sql.*;
import java.util.*;
import java.net.URL;
import java.sql.*;

public class LinkCollectionSolution
{

private Connection cn;

public LinkCollectionSolution(String dbName)
{
  //Constructor sets up a reference to the database containing
  //links. The name of the database is dbName. Each
  //row of the database contains the URL(part of key), text description,
  //number of dead references, last email but one sent,
  //last email sent and the email address of the who registered
  //the link (part of key)
  String jdbcDriver = "sun.jdbc.odbc.JdbcOdbcDriver";
  String protocolHeader = "jdbc:odbc:";
  String user = "Darrel";
  String password = "";
  try
  {
     // Load in the driver
     Class.forName(jdbcDriver);
     // Get a connection
    cn =
       DriverManager.getConnection(protocolHeader+dbName, user, password);
  }
  catch(Exception e){System.out.println("Problem opening database"+e);}
}

public Enumeration getAllLinks()
{
  //Returns with an enumeration to all the links
  //It does this by placing each link in a Vector
  //object and then returning an enumeration to the Vector
  Vector v = new Vector(100);
  //Query selects all customers
  String query = "Select * from KeyData";
  Link retrievedLink;
  ResultSet rs;
  try
  {
     //Create and execute the SQL statement
     Statement qStatement = cn.createStatement();
     rs = qStatement.executeQuery(query);
     //Iterate around result set creating a link and then
     //placing the link in the vector
     while(rs.next())
     {
        retrievedLink = new Link
                  (new URL(rs.getString(1)),rs.getString(2),rs.getString(6));
        retrievedLink.setLastEmail(rs.getString(5));
        retrievedLink.setLastEmailButOneSent(rs.getString(4));
        retrievedLink.setNoOfDeadReferences(rs.getInt(3));
        v.add(retrievedLink);
     }
     rs.close();
  }catch(Exception e)
     {System.out.println("Problem retrieving the link collection");}
  return v.elements();
}

public Enumeration getLinksForUser(String emailAddress)
{
  //Returns with an enumeration to all the links
  //owned by a user identified by emailAddress
  //It does this by placing each link in a Vector
  //object and then returning an enumeration to the Vector
  Vector v = new Vector(100);
  //Query selects all customers
  String query = "Select * from KeyData where EmailAddress ='"
                 +emailAddress+"'";
  Link retrievedLink;
  ResultSet rs;
  try
  {
     //Create and execute the SQL statement
     Statement qStatement = cn.createStatement();
     rs = qStatement.executeQuery(query);
     //Iterate around result set creating a link and then
     //placing the link in the vector
     while(rs.next())
     {
        retrievedLink = new Link
                  (new URL(rs.getString(1)),rs.getString(2),rs.getString(6));
        retrievedLink.setLastEmail(rs.getString(5));
        retrievedLink.setLastEmailButOneSent(rs.getString(4));
        retrievedLink.setNoOfDeadReferences(rs.getInt(3));
        v.add(retrievedLink);
     }
     rs.close();
  }catch(Exception e)
     {System.out.println("Problem retrieving the link collection");}
  return v.elements();
}

public void addLink(Link add)
{
   String query = "Insert into KeyData (URL,TextDescription,NoOfDeadReferences,"+
               "LastEmailButOneSent,LastEmail,EmailAddress) values"+
               "('"+add.getLinkAddress()+"','"+add.getTextDescription()+"',"+
               add.getNoOfDeadReferences()+",'"+
               add.getLastEmailButOneSent()+"','"+add.getLastEmail()+"','"+
               add.getEmailAddress()+"')";
   try
   {
      Statement qStatement = cn.createStatement();
      qStatement.executeUpdate(query);
   }
   catch(Exception e)
      {System.out.println("Problem inserting link"+e);}

}

public void deleteLink(String emailAddress, URL urlOfLink)
{
  //Delete the link identified by the key formed by the
  //email address and the URL arguments
  String query = "Delete from KeyData where URL='"+
                  urlOfLink+"' and EmailAddress='"+emailAddress+"'";
  try
  {
     //Create and execute the SQL statement
     Statement qStatement = cn.createStatement();
     qStatement.executeUpdate(query);
  }
  catch(Exception e)
     {System.out.println("Problem accessing the link database"+e);}
}

public Link getLink(String emailAddress, URL urlOfLink)
{
  //Gets the link associated with the key formed by the two arguments
  //First, create and execute the SQL statement
  String query = "Select * from KeyData where EmailAddress ='"
                 +emailAddress+"' and URL ='"+urlOfLink+"'";
  Link retrievedLink=null;
  ResultSet rs;
  try
  {
     Statement qStatement = cn.createStatement();
     rs = qStatement.executeQuery(query);
     //Only one link returned so no need for a loop
     rs.next();
     retrievedLink = new Link
                  (new URL(rs.getString(1)),rs.getString(2),rs.getString(6));
     retrievedLink.setLastEmail(rs.getString(5));
     retrievedLink.setLastEmailButOneSent(rs.getString(4));
     retrievedLink.setNoOfDeadReferences(rs.getInt(3));
     rs.close();
     }
     catch(Exception e)
        {System.out.println("Problems getting link"+e);}
  return retrievedLink;
}

public void close()
{
   try
   {
      cn.close();
   }
   catch (Exception e)
     {System.out.println("Problem closing down links database");}
}

}