package registrationsoftware;

import java.util.*;
import java.sql.*;

//Business object class for collection of customers

public class CustomerCollection {

private Connection cn;

public CustomerCollection(String dbName)
{
  //Constructor sets up a reference to the database containing
  //customer details. The name of the database is dbName. Each
  //row of the database contains the user name, their email
  //address(the key) and the password in that order
  String jdbcDriver = "sun.jdbc.odbc.JdbcOdbcDriver";
  String protocolHeader = "jdbc:odbc:";
  String user = "Darrel";
  String password = "";
  try
  {
     // Load in the driver
     Class.forName(jdbcDriver);
     // Get a connection
    cn =
       DriverManager.getConnection(protocolHeader+dbName, user, password);
  }
  catch(Exception e){System.out.println("Problem opening database"+e);}
}

public void closeCollection()
{
  //Closes down the database holding the customer details
  try
  {
     cn.close();
  }
  catch(Exception e)
     {System.out.println("Problem closing down database");}
}


public Enumeration getCustomers()
{
  //Returns with an enumeration to all the customers
  //who have registered with the link checking service
  //It does this by placing each customer in a Vector
  //object and then returning an enumeration to the Vector
  Vector v = new Vector(100);
  //Query selects all customers
  String query = "Select * from Customers";
  Customer retrievedCustomer;
  ResultSet rs;
  try
  {
     //Create and execute the SQL statement
     Statement qStatement = cn.createStatement();
     rs = qStatement.executeQuery(query);
     //Iterate around result set creating a customer and then
     //placing the customer in the vector
     while(rs.next())
     {
        retrievedCustomer = new Customer
                  (rs.getString(1),rs.getString(3),rs.getString(2));
        v.add(retrievedCustomer);
     }
  }catch(Exception e)
     {System.out.println("Problem retrieving the customer collection");}
  return v.elements();
}


public void insertCustomer(Customer cust)
{
  //Inserts the customer cust into the collection of customers
  //uses the SQL INSERT command
  String insertCommand =
        "Insert into Customers(Name,EmailAddress,Password)values"+
        "('"+cust.getCustomerName()+"','"+
             cust.getCustomerEmailAddress()+"','"+
             cust.getCustomerPassword()+"')";
  try
  {
     //Execute the insertion statement
     Statement query = cn.createStatement();
     query.executeUpdate(insertCommand);
  }
  catch(Exception e)
  {System.out.println("Problem inserting a customer"+e);}
}

public Customer getCustomer(String emailAddress)
{
  //Return the customer with the unique email address
  //given as the argument
  String query =
      "Select * from Customers where EmailAddress = '"+emailAddress+"'";
  Customer retrievedCustomer=null;
  ResultSet rs;
  try
  {
     //Create and execute the SQL statement
     Statement qStatement = cn.createStatement();
     rs = qStatement.executeQuery(query);
     //Since retrieval is on a key a single customer is retrieved
     //Hence there is no need for a loop
     rs.next();
     retrievedCustomer = new Customer
                         (rs.getString(1),rs.getString(3),rs.getString(2));
  }catch(Exception e)
     {System.out.println("Problem retrieving the customer"+e);}
  return retrievedCustomer;
}

}