package registrationsoftware;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class RegistrationAppletSolution extends Applet
                                implements ActionListener{

boolean isStandalone = false;
private Button registrationButton;
private TextField password, retypedPassword,
        name, emailAddress;
private CustomerCollection customers;


//Construct the applet
public RegistrationAppletSolution()
{
}

//Initialize the applet
public void init()
{
    registrationButton = new Button("Register");
    //Set up password fields, the * character will display when any
    //character is typed in by the user into these two fields
    password = new TextField(30);
    password.setEchoChar('*');
    retypedPassword = new TextField(30);
    retypedPassword.setEchoChar('*');
    //Set up the rest of the visual interface
    name = new TextField("Type your name here",30);
    emailAddress = new TextField("Type your email address here",25);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
}

//Component initialization
private void jbInit() throws Exception
{
  //Add all visual objects to the applet
  customers = new CustomerCollection("customers");
  this.setLayout(new FlowLayout());
  add(new Label("Your name"));
  add(name);
  add(new Label("Your email address"));
  add(emailAddress);
  add(new Label("Your chosen password"));
  add(password);
  add(new Label("Please retype password"));
  add(retypedPassword);
  add(registrationButton);
  registrationButton.addActionListener(this);
}

public void actionPerformed(ActionEvent ae)
{
  //Register button has been clicked
  if(!password.getText().equals(retypedPassword.getText()))
     showStatus("Passwords typed in must be the same");
  else
     {
     //Create a new customer from input data
     Customer inCustomer = new Customer(name.getText(),
                                        password.getText(),
                                        emailAddress.getText());
     //Insert the customer
     customers.insertCustomer(inCustomer);
     showStatus("You are now registered");
     }
}

public void stop()
{
  //Applet has been stopped close down custoemr collection
  customers.closeCollection();
}

}