package eclient;

import java.io.*;
import java.net.*;
import java.awt.*;

//*****************************************************************************
//Ignore code from this point on until next asterisked
//code it just sets up visual objects
//*****************************************************************************

public class EClient extends Frame
{

PrintWriter pw;
BufferedReader bf;
String productIdentity;
public EClient()
{
   SymWindow aSymWindow = new SymWindow();
   this.addWindowListener(aSymWindow);
   SymAction lSymAction = new SymAction();
   productButton.addActionListener(lSymAction);
   quantityButton.addActionListener(lSymAction);
   quitButton.addActionListener(lSymAction);
   setLayout(null);
   setSize(405,305);
   setVisible(false);
   add(queryResults);
   queryResults.setBounds(24,36,168,108);
   add(productId);
   productId.setBounds(24,180,216,26);
   productButton.setLabel("Product name");
   add(productButton);
   productButton.setBackground(java.awt.Color.lightGray);
   productButton.setBounds(24,240,84,40);
   quantityButton.setLabel("Product quantity");
   add(quantityButton);
   quantityButton.setBackground(java.awt.Color.lightGray);
   quantityButton.setBounds(120,240,108,40);
   quitButton.setLabel("Quit");
   add(quitButton);
   quitButton.setBackground(java.awt.Color.lightGray);
   quitButton.setBounds(240,240,60,40);
   resultsLabel.setText("Results");
   add(resultsLabel);
   resultsLabel.setBounds(24,12,100,24);
   productIDLabel.setText("Product ID");
   add(productIDLabel);
   productIDLabel.setBounds(24,156,72,24);
   setTitle("Exercise 3.1 Client");
}

public EClient(String title)
{
   this();
   setTitle(title);
}

static public void main(String args[])
{
   try
   {
      //Create a new instance of our application's frame, and make it visible.
      (new EClient()).setVisible(true);
   }
   catch (Throwable t)
   {
      System.err.println(t);
      t.printStackTrace();
      //Ensure the application exits with an error condition.
      System.exit(1);
   }
}

public void addNotify()
{
   // Record the size of the window prior to calling parents addNotify.
   Dimension d = getSize();
   super.addNotify();
   if (fComponentsAdjusted)
      return;
   // Adjust components according to the insets
   setSize(getInsets().left + getInsets().right + d.width,
          getInsets().top + getInsets().bottom + d.height);
   Component components[] = getComponents();
   for (int i = 0; i < components.length; i++)
   {
      Point p = components[i].getLocation();
      p.translate(getInsets().left, getInsets().top);
      components[i].setLocation(p);
   }
   fComponentsAdjusted = true;
}

// Used for addNotify check.
boolean fComponentsAdjusted = false;
java.awt.TextArea queryResults = new java.awt.TextArea();
java.awt.TextField productId = new java.awt.TextField();
java.awt.Button productButton = new java.awt.Button();
java.awt.Button quantityButton = new java.awt.Button();
java.awt.Button quitButton = new java.awt.Button();
java.awt.Label resultsLabel = new java.awt.Label();
java.awt.Label productIDLabel = new java.awt.Label();

class SymWindow extends java.awt.event.WindowAdapter
{
   public void windowClosing(java.awt.event.WindowEvent event)
   {
      Object object = event.getSource();
      if (object == EClient.this)
         Frame1_WindowClosing(event);
   }
}

void Frame1_WindowClosing(java.awt.event.WindowEvent event)
{
   Frame1_WindowClosing_Interaction1(event);
}

void Frame1_WindowClosing_Interaction1(java.awt.event.WindowEvent event)
{
   try {
      System.exit(0);
   } catch (Exception e) {
}
}


class SymAction implements java.awt.event.ActionListener
{
public void actionPerformed(java.awt.event.ActionEvent event)
{
   Object object = event.getSource();
   if (object == productButton)
   productButton_ActionPerformed(event);
   else if (object == quantityButton)
   quantityButton_ActionPerformed(event);
   else if (object == quitButton)
   quitButton_ActionPerformed(event);
}
}

//*****************************************************************************
//End of ignored code
//*****************************************************************************

void productButton_ActionPerformed(java.awt.event.ActionEvent event)
{
    // Code for processing when product button is clicked
    // Pick up string in productIdentity text field
    productIdentity = productId.getText();
    try
    {
      // Socket established on port 1200 of server
      Socket s = new Socket("127.0.0.1", 1200);
      // Set up reader and writer
      pw = new PrintWriter(s.getOutputStream(),true);
      bf = new BufferedReader(new InputStreamReader(s.getInputStream()));
      // Send request for product name place your code here

      //Read name sent back from server place your code here

      String name = null;
      name = bf.readLine();
      if(name.charAt(0)=='*')
     {
        // Error product not recognised
        queryResults.setText("Error");
     }
     else
     {
        //Place name on the Text area with message
        queryResults.setText("");
        queryResults.setText("Name of "+productIdentity+" =  "+name);
     }
     // close down connection, in a practical system this would be
     // closed down when the client terminated
     pw.close();
     s.close();
     bf.close();
   }catch(Exception ex)
     {System.out.println("Problem establishing a connection ");}
}

void quantityButton_ActionPerformed(java.awt.event.ActionEvent event)
{
    // Code for processing when quantity button isclicked
    // Pick up string in productIdentity text field
    productIdentity = productId.getText();
    try
    {
      // Socket established on port 1200 of server
      Socket s = new Socket("127.0.0.1", 1200);
      // Set up reader and writer
      pw = new PrintWriter(s.getOutputStream(),true);
      bf = new BufferedReader
            (new InputStreamReader(s.getInputStream()));
      // Send request for quantity of product
      pw.println("Q"+productIdentity);
      //Read quantity sent back from server
      String quantity = bf.readLine();
      if(quantity.charAt(0)=='*')
      {
         // Error product not recognised
         queryResults.setText("Error");
      }
      else
      {
         //Place quantity on the Text area with message
         queryResults.setText("");
         queryResults.setText("Quantity of "+productIdentity+" = "+quantity);
      }
      // close down connection, in a pratical system this would be
      // closed down when the client terminated
      pw.close();
      s.close();
      bf.close();
   }catch(Exception ex)
      {System.out.println("Problem establishing a connection ");}
}

void quitButton_ActionPerformed(java.awt.event.ActionEvent event)
{
   System.exit(0);
}

}

