package hubandspoke;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;


public class Client extends Frame implements ActionListener{

private Button registerButton,   // Registers a client with the server
               quitButton;       // Client quits
private TextArea messages;       // Contains messages for user
private Socket sock;
private String clientIdentity;
private PrintWriter pw;
private boolean registered;  //True if client is registered with server
private ClientThread connectionThread; //Handles connections
private OutputStream out;
private InputStream in;
private BufferedReader bfi;

  public Client(String title)
  {
     //Set up all the visual objects
     super(title);
     registered = false;
     clientIdentity = title;
     this.setSize(500,500);
     setLayout(new FlowLayout());
     registerButton = new Button("Register");
     quitButton = new Button("Quit");
     Label messagelabel = new Label("Messages");
     messages = new TextArea(30,30);
     add(messagelabel);
     add(messages);
     add(registerButton);
     add(quitButton);
     registerButton.addActionListener(this);
     quitButton.addActionListener(this);
     setVisible(true);
     try
     {
        //Set up connections
        sock = new Socket("127.0.0.1", 2001); //Use localhost loopback address
        out = sock.getOutputStream();
        in = sock.getInputStream();
        bfi = new BufferedReader(new InputStreamReader(in));
        pw = new PrintWriter(out, true);
        connectionThread = new ClientThread(messages, bfi);
        connectionThread.start();
      }
      catch(Exception e)
           {System.out.println("Problem with connection"+e);};
  }

  public void closeAll()
  {
     //Close all streams and connections
     try
     {
        bfi.close();
        pw.close();
        sock.close();
        out.close();
        in.close();
     }
     catch(Exception e)
     {System.out.println("Problem with closing"+e);}
  }

  public void actionPerformed(ActionEvent ae)
  {
    if(ae.getSource()==registerButton)
    {
       //Client has tried to register
       if (!registered)
       {
          registered = true;
          //Send identity
          pw.println(clientIdentity);
      }
    }
    if(ae.getSource()==quitButton)
    {
       //Client has quit Send identity
       if(registered)
       {
          pw.println(clientIdentity);
          closeAll();
        }
       System.exit(0);
    }
  }

  public static void main(String[] args)
  {
     //Set up frame take title from command line
     Client cl = new Client("Client1");
  }

}