package server;

import java.net.*;
import java.util.Hashtable;
import java.io.*;
import javax.swing.*;

public class ConnectionHandler implements Runnable{

  private Socket sock;
  //Hashtable used to map client identities to the
  //PrintWriter object they are connected to
  private Hashtable connectionMap;
  private PrintWriter pw;


  public ConnectionHandler(Socket sock, Hashtable connectionMap)
  {
     this.sock = sock;
     this.connectionMap = connectionMap;
  }

  //Thread method run executed when server has detected a connection
  public void run()
  {
      try
      {
         //Set up streams
         InputStream is = sock.getInputStream();
         BufferedReader br = new BufferedReader
                                   (new InputStreamReader(is));
         //Client has sent message asking to be registered
         String clientIdentity = br.readLine();
         System.out.println(clientIdentity +" registered");
         pw = new PrintWriter(sock.getOutputStream(), true);
         //Connect client to PrintWriter object and register them
         connectionMap.put(clientIdentity,pw);
         //Client has now sent a deregistration message
         clientIdentity = br.readLine();
         System.out.println(clientIdentity +" deregistered");
         //Send KILL message to client
         pw.println("KILL");
         connectionMap.remove(clientIdentity);
         //Close client connection resources
         pw.close();
         br.close();
         is.close();
      }
      catch (Exception e)
         {System.out.println("Problem setting up thread"+e);}
  }

}