package server;

import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class ServerSolution extends Frame
{
private Hashtable connectionMap; // Relates clients to PrintWriter objects
private ServerSocket ss;

//****************************************************************************
//Ignore up to next asterisked comments, just sets up visual obejcts
//****************************************************************************

public ServerSolution()
{
   SymWindow aSymWindow = new SymWindow();
   this.addWindowListener(aSymWindow);
   SymAction lSymAction = new SymAction();
   sendButton.addActionListener(lSymAction);
   quitButton.addActionListener(lSymAction);
   startButton.addActionListener(lSymAction);
   setLayout(null);
   setSize(405,305);
   setVisible(true);
   sendButton.setLabel("Send");
   add(sendButton);
   sendButton.setBackground(java.awt.Color.lightGray);
   sendButton.setBounds(60,72,60,40);
   quitButton.setLabel("Quit");
   add(quitButton);
   quitButton.setBackground(java.awt.Color.lightGray);
   quitButton.setBounds(60,120,60,40);
   startButton.setLabel("Start");
   add(startButton);
   startButton.setBackground(java.awt.Color.lightGray);
   startButton.setBounds(60,168,60,40);
   add(messagesOut);
   messagesOut.setBounds(156,120,237,24);
   sentLabel.setText("Message to be sent");
   add(sentLabel);
   sentLabel.setBounds(156,84,144,40);
   setTitle("Exercise 4.2 Hub Server");
   try
   {
      int count =0;
      ss = new ServerSocket(2001);
      //Loop around waiting for a connection
      while(true)
      {
         count++;
         Socket sock = ss.accept();
         //When a connection comes in set up a new thread to deal with it
         Thread connThread = new Thread
                      (new ConnectionHandler(sock, connectionMap));
         connThread.start();
         System.out.println("...Connection thread "+count + " Established");
       }
    }
    catch(Exception e) {
      e.printStackTrace();
    }
}

public ServerSolution(String title)
{
   this();
   setTitle(title);
}

static public void main(String args[])
{
   try
   {
      //Create a new instance of our application's frame, and make it visible.
      (new ServerSolution()).setVisible(true);
   }
   catch (Throwable t)
   {
      System.err.println(t);
      t.printStackTrace();
      //Ensure the application exits with an error condition.
      System.exit(1);
   }
}

public void addNotify()
{
   // Record the size of the window prior to calling parents addNotify.
   Dimension d = getSize();
   super.addNotify();
   if (fComponentsAdjusted)
      return;
   // Adjust components according to the insets
   setSize(getInsets().left + getInsets().right +
           d.width, getInsets().top + getInsets().bottom + d.height);
   Component components[] = getComponents();
   for (int i = 0; i < components.length; i++)
   {
      Point p = components[i].getLocation();
      p.translate(getInsets().left, getInsets().top);
      components[i].setLocation(p);
   }
   fComponentsAdjusted = true;
}

// Used for addNotify check.
boolean fComponentsAdjusted = false;

java.awt.Button sendButton = new java.awt.Button();
java.awt.Button quitButton = new java.awt.Button();
java.awt.Button startButton = new java.awt.Button();
java.awt.TextField messagesOut = new java.awt.TextField();
java.awt.Label sentLabel = new java.awt.Label();


class SymWindow extends java.awt.event.WindowAdapter
{
   public void windowClosing(java.awt.event.WindowEvent event)
   {
      Object object = event.getSource();
      if (object == ServerSolution.this)
       Frame1_WindowClosing(event);
   }
}

void Frame1_WindowClosing(java.awt.event.WindowEvent event)
{
   Frame1_WindowClosing_Interaction1(event);
}

void Frame1_WindowClosing_Interaction1(java.awt.event.WindowEvent event)
{
   try {
      System.exit(0);
   } catch (Exception e) {
}
}


class SymAction implements java.awt.event.ActionListener
{
   public void actionPerformed(java.awt.event.ActionEvent event)
   {
   Object object = event.getSource();
   if (object == sendButton)
      sendButton_ActionPerformed(event);
   else if (object == quitButton)
      quitButton_ActionPerformed(event);
   else if (object == startButton)
      startButton_ActionPerformed(event);
}
}
//*****************************************************************************
//End of ignored section
//*****************************************************************************

void sendButton_ActionPerformed(java.awt.event.ActionEvent event)
{
     //Send button clicked -- a message has to be sent
     System.out.println("...Sending");
     Enumeration en = connectionMap.keys();
     PrintWriter pw;
     //Loop around hash table extracting out the print writer objects
     //associated with each client
     while(en.hasMoreElements())
     {
        String keyValue = (String)en.nextElement();
        //Get the print writer object
        pw = (PrintWriter)connectionMap.get(keyValue);
        //send the message
        pw.println(messagesOut.getText());
     }
}

void quitButton_ActionPerformed(java.awt.event.ActionEvent event)
{
   //Quit button clicked -- exit
   System.exit(0);
}

void startButton_ActionPerformed(java.awt.event.ActionEvent event)
{
//Start button clicked
  try
  {
     connectionMap = new Hashtable();
     System.out.println("...Server starting");
  }
  catch (Exception ex)
     {System.out.println("Problem setting up the server"+ex);}
}

}

