package ex53;

import java.sql.*;

public class DBQuerySolution
{

public static void main(String[] args)
{
   String jdbcDriver = "sun.jdbc.odbc.JdbcOdbcDriver";
   String protocolHeader = "jdbc:odbc:";
   String dbName = "products";
   String user = "Darrel";
   String password = "";
   System.out.println("***Solution being executed***");
   try
   {
   // Load in the driver
   Class.forName(jdbcDriver);
   System.out.println("...Driver loaded");
   // Establish a connection
   Connection cn =
      DriverManager.getConnection(protocolHeader+dbName, user, password);
   System.out.println("...Connection established");
   // Get the database metadata
   DatabaseMetaData dbmd = cn.getMetaData();
   System.out.println();
   // Display product name
   System.out.println ("The name of the product is "+
                                dbmd.getDatabaseProductName());
   // Display version name
   System.out.println ("The version of the product is "+
                                     dbmd.getDatabaseProductVersion());
   // Check if the database supports stored procedures
   if (dbmd.supportsStoredProcedures())
      System.out.println ("The product supports stored procedures");
   else
      System.out.println ("The product does not support stored procedures");
   //Display maximum length of a row in bytes
   System.out.println ("The maximum length of a row is "+
                                 dbmd.getMaxRowSize()+" bytes");
   }
   catch (Exception e)
      {System.out.println("Problem accessing the database "+e);}
    }
}