package imagemap;

import java.awt.*;
import java.util.*;
import java.awt.event.*;

public class RectangleCanvas extends Canvas  implements MouseMotionListener {

public Rectangle[] squareStore;
public int squareCount;

public RectangleCanvas()
{
   super();
   setSize(300,300);
   squareCount =0;
   squareStore = new Rectangle[100];
   this.addMouseMotionListener(this);
}

public void mouseDragged(MouseEvent me)
{
//Not interested in mosue dragging so no code here
}

public void mouseMoved(MouseEvent me)
{
   int xCoord = me.getX();
   int yCoord = me.getY();
   for(int j =0;j<squareCount;j++)
   {
      if(squareStore[j].isIn(xCoord, yCoord))
      {
         squareStore[j].setPasssoverColour();
      }
      else
         squareStore[j].setOriginalColour();
   }
   repaint();
}

public void addSquare(Rectangle rect)
{
   squareStore[squareCount] = rect;
   squareCount++;
   repaint();
}

public void paint(Graphics g)
{
   for(int i =0;i<squareCount;i++)
   {
      Rectangle rect = squareStore[i];
      g.setColor(rect.getDrawColour());
      g.fill3DRect
      (rect.getXCoordinate(), rect.getYCoordinate(),
       rect.getXLength(),rect.getYLength(),false);
   }
}

}