package servletcommercial;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class CommServletSolution extends HttpServlet {

private static final String CONTENT_TYPE = "text/html";
private ProductCollection pc = new ProductCollection();

//Initialize global variables
public void init(ServletConfig config) throws ServletException
{
    super.init(config);
}

//Process the HTTP Get request
public void doGet(HttpServletRequest request, HttpServletResponse response)
     throws ServletException, IOException
{
}

//Process the HTTP Put request
public void doPost(HttpServletRequest request, HttpServletResponse response)
                            throws ServletException, IOException
{
    PrintWriter out = response.getWriter();
    response.setContentType(CONTENT_TYPE);

    //Price selection query
    if((request.getParameter("pulldown")).equals("priceselect"))
    {
       String price = request.getParameter("data");
       String priceInPence = (Integer.parseInt(price)*100)+"";
       //Get enumeration to retrieved products
       Enumeration en = pc.getCollectionPrice(Integer.parseInt(priceInPence));
       //Display table
       out.print("<P>The table of goods for your price query ** price "+" > " +
                price+" ** is shown below</P>");
       displayTable(out, en);
    }

    //Product category query
    if((request.getParameter("pulldown")).equals("categoryselect"))
    {
        String category = request.getParameter("data");
        //Get enumeration to retrieved products
        Enumeration en = pc.getCollectionCategory(category);
        //Display table
        out.print("<P>The table of goods for your category query ** category = "+
                 category +" ** is shown below</P>");
        displayTable(out, en);
    }
}

public static void  displayTable(PrintWriter out, Enumeration en)
{
      //Helper method which displays tables

      //Table header
       out.println("<TABLE BORDER>");
       out.println("<TR>");
       out.println("<TH>Description</TH><TH>Category</TH><TH>Quantity</TH><TH>Price</TH>");
       out.println("</TR>");
       //Table rows
       while(en.hasMoreElements())
       {
          Product chosenProduct = (Product)en.nextElement();
          //Tacky adjustment of pence amount in price!!
          int penceAmount = chosenProduct.getPrice()%100;
          String pence=""+penceAmount;
          if(penceAmount<10)
             pence = "0"+penceAmount;
          if(penceAmount==0)
             pence ="00";
          out.println("<TR>");
          out.println("<TD>"  + chosenProduct.getDescription()+"</TD>"+
                      "<TD>"  + chosenProduct.getCategory()+ "</TD>"+
                      "<TD>"  + chosenProduct.getQuantityInStock()+"</TD>"+
                      "<TD>"  + chosenProduct.getPrice()/100+"."+
                                pence+"</TD>"
                      );
          out.println("</TR>");
       }
       out.println("</TABLE>");
}

}