package persistentcounter;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class PersistentCounterSolution extends HttpServlet {

private static final String CONTENT_TYPE = "text/html";
private static int count;

//Set up variables for file holding the persistent count
private String fileName;
private BufferedReader bf = null;
private FileReader fin = null;
PrintWriter pw = null;
private int visitCount=0;

//Initialize global variables
public void init(ServletConfig config) throws ServletException
{
     super.init(config);
     try
     {
       //Get number of visits from file
       fileName = "visits.txt";
       System.out.println(fileName);
       fin = new FileReader(fileName);
       bf = new BufferedReader(fin);
       visitCount =Integer.parseInt(bf.readLine());
     }
     catch(Exception e) {
        e.printStackTrace();
    }
}

//Code which writes persistent count and closes files
public void closeFilesAndWrite()
{
  try
  {
     //Close down file
     bf.close();
     fin.close();
     //Set up new file for writing the visitor count
     pw = new PrintWriter(new FileWriter(fileName));
     //Write the visitor count
     pw.println(visitCount);
     pw.close();
  }
  catch(Exception e){}
}

//Process the HTTP Get request
public void doGet(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException
{
    //Increment visitor count
    visitCount++;
    //Send current value of visitor count
    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    //Write out the HTML
    out.println("<font color=\"green\">");
    out.println("<p>There have been "+ visitCount+" visits </P>");
    out.println("</font>");
    //Close file and write visitor count to file
    closeFilesAndWrite();
}

  //Clean up resources
  public void destroy()
  {
     closeFilesAndWrite();
  }
}