package relationalsax;

import org.xml.sax.*;
import java.sql.*;

public class CatalogueSAXSolution extends HandlerBase{

private Connection cn = null;
private String elementName;
private BookDetails book = new BookDetails();

public CatalogueSAXSolution()
{
}

public static void main(String[] args)
{
   try
   {
      System.out.println("***Solution executing***");
      //Set up the parser and execute it
      Class loadedClass = Class.forName("com.ibm.xml.parser.SAXDriver");
      Parser xParser = (Parser)loadedClass.newInstance();
      CatalogueSAXSolution cs = new CatalogueSAXSolution();
      xParser.setDocumentHandler(cs);
      xParser.parse("catalogue.txt");
   }
   catch(Exception e)
      {System.out.println("Problem starting XML processor "+e);}
}

public void startDocument() throws SAXException
{
   System.out.println("...Document started");
   //Sets up all the parameters for connections etc
   String jdbcDriver = "sun.jdbc.odbc.JdbcOdbcDriver";
   String protocolHeader = "jdbc:odbc:";
   String dbName = "DOMbooks";
   String user = "Darrel";
   String password = "";
   try
   {
      // Load in the driver
      Class.forName(jdbcDriver);
      System.out.println("...Driver loaded");
      // Get a connection
      cn =
        DriverManager.getConnection(protocolHeader+dbName, user, password);
      System.out.println("...Connection established");
      System.out.println("*****SQL STATEMENTS EXECUTED*****");
   }
   catch (Exception e)
      {System.out.println("Problem with database"+e);}
}

public void startElement(String elementName, AttributeList al) throws SAXException
{
   //Executed when an element is encountered
   String attributeName=null, attributeValue=null;
   if (elementName.equals("BOOK"))
      //Set default discount
      book.setDiscount("0");
   this.elementName = elementName;
   if(al.getLength()>0)
   for(int j = 0;j<al.getLength();j++)
   {
      //Set values for the attributes AMOUNTCURRENCY and DISCOUNT
      attributeName = al.getName(j);
      attributeValue = al.getValue(j);
      //Update book, note that curly brackets are not strictly needed,
      //they are there so that the class CatalogueSAX will compile
      //correctly
      if(attributeName.equals("AMOUNTCURRENCY"))
      {
         book.setCurrency(attributeValue);
      }
      if(attributeName.equals("DISCOUNT"))
      {
         book.setDiscount(attributeValue);
      }
   }
}

public void endElement(String elementName) throws SAXException
{
   //Executed when an end element such as </BOOK> is encoutnered
   try
   {
      //At the end of a BOOK element in the XML insert a row of book details
      if (elementName.equals("BOOK"))
      {
       Statement query = cn.createStatement();
       String queryString =
                      "INSERT INTO BookDetails(Title, Authors, Price, Publisher,AmountCurrency,Discount) VALUES"+
                      "('"+book.getTitle() + "','" +
                      book.getAuthors() + "','" +
                      book.getPrice() + "','" +
                      book.getPublisher()+ "','" +
                      book.getCurrency()+ "','" +
                      book.getDiscount()+"')";
       System.out.println(queryString);
       query.executeUpdate(queryString);
       }
    }
       catch(SQLException sq){System.out.println("Problem executing the database query"+sq.getMessage());}
}

public void endDocument() throws SAXException
{
   try
   {
      //Display contents of database
      Statement query = cn.createStatement();
      String queryString = "SELECT * FROM BookDetails";
      ResultSet rs = query.executeQuery(queryString);
      System.out.println("*******CONTENTS OF DATABASE*******");
      while(rs.next())
      {
         String row = rs.getString(1)+" "+rs.getString(2)+ " "+rs.getString(3)+" "+
                      rs.getString(4)+" "+rs.getString(5)+ " "+rs.getString(6);
         System.out.println( "Row added = " +row);
      }
      query.close();
      //Delete the contents of database
      query = cn.createStatement();
      queryString = "DELETE FROM BookDetails";
      query.executeUpdate(queryString);
      System.out.println("...Database deleted");
    }
    catch(Exception e){System.out.println("Problem terminating"+e);};

System.out.println("...Document finished");
}

public void characters(char[] chars, int start, int length)throws SAXException
{
//Executed when a string is encountered
//Insert values for title, authors, price and publisher
String stringValue = new String(chars, start, length);
if(elementName.equals("TITLE"))
   book.setTitle(stringValue);
if(elementName.equals("AUTHORS"))
   book.setAuthors(stringValue);
if(elementName.equals("PRICE"))
   book.setPrice(stringValue);
if(elementName.equals("PUBLISHER"))
   book.setPublisher(stringValue);
}

}