package domrel;

import org.w3c.dom.*;

import com.ibm.xml.parser.Parser;
import java.io.*;
import java.sql.*;

public class DOMRelational {


private static Connection cn;
//book is going to be updated every time a BOOK element is red in the XML source
private static BookDetails book = new BookDetails();
private static String nodeName;

public DOMRelational()
{
}

public static void processXML(Node nd)
{
   short nodeVal = nd.getNodeType();

   if(nd.ENTITY_REFERENCE_NODE==nodeVal)
   {
      //Do nothing
   }

   if(nd.DOCUMENT_TYPE_NODE==nodeVal)
   {
      //Do nothing
   }

   if(nd.DOCUMENT_NODE==nodeVal)
   {
      System.out.println("...Document started");
      //Sets up all the parameters for connections etc
      String jdbcDriver = "sun.jdbc.odbc.JdbcOdbcDriver";
      String protocolHeader = "jdbc:odbc:";
      String dbName = "DOMbooks";
      String user = "Darrel";
      String password = "";
      try
      {
        //Load in the driver
        Class.forName(jdbcDriver);
        System.out.println("...Driver loaded");
        //Get a connection
        cn =
          DriverManager.getConnection(protocolHeader+dbName, user, password);
        System.out.println("...Connection established");
        System.out.println("*****SQL STATEMENTS EXECUTED*****");
      }
      catch (Exception e){System.out.println("Problem with database"+e);}
      processXML(((Document) nd).getDocumentElement());
   }

   if(nd.ELEMENT_NODE==nodeVal)
   {
      //Node is an element
      String localNodeName;
      nodeName = nd.getNodeName();
      localNodeName = nodeName;
      NamedNodeMap nm = nd.getAttributes();
      //Get any attributes
      if (nm!=null)
      {
         for(int k=0; k<nm.getLength();k++)
         {
            Node currAttribute = nm.item(k);
            String attributeName = currAttribute.getNodeName();
            String attributeValue = currAttribute.getNodeValue();
            //The only element which has attributes is PRICE
            //set up the book details for these attributes
            if(attributeName.equals("AMOUNTCURRENCY"))
               book.setCurrency(attributeValue);
            if(attributeName.equals("DISCOUNT"))
               book.setDiscount(attributeValue);
         }
      }
      //Get any child nodes and process them
      NodeList nl = nd.getChildNodes();
      if(nl!=null)
      {
         for(int j = 0; j<nl.getLength();j++)
            processXML(nl.item(j));
      }

      //Executed when </BOOKLIST> is encountered as the initial call on
      //processXML will have already read <BOOKLIST>
      if(localNodeName.equals("BOOKLIST"))
      {
         //terminate processing, display the contents of the book list from
         //the relational database and delete the database ready for the
         //next execution
         try
         {
            //Display contents of database after processing has completed
            Statement query = cn.createStatement();
            //Select every row from the database
            String queryString = "SELECT * FROM BookDetails";
            //Execute the query
            ResultSet rs = query.executeQuery(queryString);
            System.out.println("*******CONTENTS OF DATABASE*******");
            while(rs.next())
            {
               String row = rs.getString(1)+" "+rs.getString(2)+ " "+
                            rs.getString(3)+" "+ rs.getString(4)+" "+
                            rs.getString(5)+ " "+rs.getString(6);
               System.out.println( "Row added = " +row);
            }
            query.close();
            //Delete the contents of database
            query = cn.createStatement();
            queryString = "DELETE FROM BookDetails";
            query.executeUpdate(queryString);
         }
         catch(Exception e){System.out.println("Problem terminating"+e);};
      }

      //End of BOOK encountered
      if(localNodeName.equals("BOOK"))
      {
         try
         {
             Statement query = cn.createStatement();
             //Form insertion SQL statement from contents of book, this will
             //have been updated by other code below when text is encountered
             String queryString =
             "INSERT INTO BookDetails(Title, Authors, Price, Publisher,AmountCurrency,Discount) VALUES"+
              "('"+book.getTitle() + "','" +
              book.getAuthors() + "','" +
              book.getPrice() + "','" +
              book.getPublisher()+ "','" +
              book.getCurrency()+ "','" +
              book.getDiscount()+"')";
              //Display the query to student
              System.out.println(queryString);
              //Execute the query
              query.executeUpdate(queryString);
         }
         catch(Exception e){System.out.println("Problem with updating database"+e);}
       }
     }

     if(nd.CDATA_SECTION_NODE==nodeVal)
     {
        //Do nothing
     }

     //Text encountered
     if(nd.TEXT_NODE==nodeVal)
     {
        String text = nd.getNodeValue();
        String name = nd.getNodeName();
        //Update book
        if(!text.equals("\n"))
        {
           //The title of the book has been encountered
           if(nodeName.equals("TITLE"))
              book.setTitle(text);
           //The authors of the book has been encountered
           if(nodeName.equals("AUTHORS"))
              book.setAuthors(text);
           //The price of the book has been encountered
           if(nodeName.equals("PRICE"))
              book.setPrice(text);
           //The publisher of the book has been encountered
           if(nodeName.equals("PUBLISHER"))
              book.setPublisher(text);
        }
     }

     if(nd.PROCESSING_INSTRUCTION_NODE==nodeVal)
     {
        //Do nothing
     }

}

public static void main(String[] args)
{
   try
   {
      //Set up parser
      String file = "catalogue.txt";
      InputStream inStream = new FileInputStream(file);
      Parser dp = new Parser(file);
      Document doc = dp.readStream(inStream);
      //Process the XML
      processXML(doc);
   }
   catch(Exception e)
      {System.out.println("Problem with XML processor"+e);}
}

}