package graphicsxml;

import java.awt.*;


public class DrawCanvas extends Canvas {

//Canvas holds circles in circles and lines in lines
private Circle[] circles;
private Line[] lines;
private int noOfCircles;
private int noOfLines;


public DrawCanvas()
{
   super();
   noOfCircles =0;
   noOfLines = 0;
   //Maximum 200 circles and lines to be drawn
   circles = new Circle [200];
   lines = new Line [200];
}

public void addLine(Line l)
{
   //Adds a line to the canvas
   lines[noOfLines] = l;
   noOfLines++;
}

public void addCircle(Circle c)
{
   //Adds a circle to the canvas
   circles[noOfCircles] = c;
   noOfCircles++;
}

public void paint(Graphics g)
{
   //Draw the lines
   for(int j = 0;j<noOfLines;j++)
   {
      Line toDraw = lines[j];
      g.drawLine
      (toDraw.getXStart(),toDraw.getYStart(),
      toDraw.getXFinish(),toDraw.getYFinish());
   }
   //Draw the circles
   for(int j = 0;j<noOfCircles;j++)
   {
      Circle toDraw = circles[j];
      int diameter = toDraw.getDiameter();
      g.drawOval
         (toDraw.getXPosition(), toDraw.getYPosition(),
         diameter, diameter);
   }
}

public void drawShapes()
{
   //Calls paint via repaint to do the drawing
   repaint();
}

}