package graphicsxml;

import org.xml.sax.*;

public class XMLGraphicsProcessor extends HandlerBase{

// Carries out the drawing of the shapes by processing the XML file

private DrawFrame df;

public XMLGraphicsProcessor()
{
}

public static void main(String[] args)
{
   try
   {
      System.out.println("***Student Solution Executing***");
      //Start the parser
      Class loadedClass = Class.forName("com.ibm.xml.parser.SAXDriver");
      Parser xParser = (Parser)loadedClass.newInstance();
      XMLGraphicsProcessor xmlg= new XMLGraphicsProcessor();
      xParser.setDocumentHandler(xmlg);
      xParser.setErrorHandler(xmlg);
      //XMl source found in shapelist.txt
      xParser.parse("shapelist.txt");
    }
    catch(Exception e)
       {System.out.println("Problem starting XML processor "+e);}
  }

public void startDocument() throws SAXException
{
   //Start of XML processing
   System.out.println("Document started");
   df = new  DrawFrame("XML Test");
   df.setSize(300,300);
   df.setVisible(true);
}

public void warning(SAXParseException sp)
{
   //Small error occured in XML file
   System.out.println("Warning: problem with parsing"+sp.getMessage());
}

public void error(SAXParseException sp)
{
   //Major error occured in XML file
   System.out.println("Error: problem with parsing"+sp.getMessage());
}

public void startElement(String elementName, AttributeList al) throws SAXException
{
   //Reads the first element, for example <LINE>
   String attributeName, attributeValue;
   int xStartPos=0, yStartPos=0, xFinishPos=0, yFinishPos=0;
   int xPos=0, yPos=0, diameter=0;
   //Line encountered
   if(elementName.equals("LINE"))
   {
      //Get attributes
      for(int j = 0;j<al.getLength();j++)
      {
         attributeName = al.getName(j);
         attributeValue = al.getValue(j);
         if(attributeName.equals("XSTARTPOS"))
            xStartPos = Integer.parseInt(attributeValue);
         if(attributeName.equals("YSTARTPOS"))
            yStartPos = Integer.parseInt(attributeValue);
         if(attributeName.equals("XFINISHPOS"))
            xFinishPos = Integer.parseInt(attributeValue);
         if(attributeName.equals("YFINISHPOS"))
            yFinishPos = Integer.parseInt(attributeValue);
      }
      //Draw line
      df.addLine(new Line(xStartPos, yStartPos, xFinishPos, yFinishPos));
   }
   //Circle encountered
   if(elementName.equals("CIRCLE"))
   {
      //Get attributes, code goes below

      //Draw circle
      df.addCircle(new Circle(xPos, yPos, diameter));
   }
}


public void endDocument() throws SAXException
{
   //End of XML source, draw the shapes
   df.drawShapes();
   System.out.println("Document finished");
}

}