package domparsing;


import org.w3c.dom.*;
import com.ibm.xml.parser.Parser;
import java.io.*;


public class DOMParser {

public DOMParser()
{
}

public static void displayXML(Node nd)
{
   //Warning this method is recursive. If you have not met recursion before
   //then ignore this project

   short nodeVal = nd.getNodeType();

   if(nd.ENTITY_REFERENCE_NODE==nodeVal)
   {
      //Do nothing
   }

   if(nd.DOCUMENT_TYPE_NODE==nodeVal)
   {
      //Do nothing
   }

   if(nd.DOCUMENT_NODE==nodeVal)
   {
      //This is a document node apply displayXML again
      displayXML(((Document) nd).getDocumentElement());
   }

   if(nd.ELEMENT_NODE==nodeVal)
   {
      //This is an element node get the name of the node
      String nodeName = nd.getNodeName();
      System.out.println("Name of Node = "+ nodeName);
      //Get the attributes
      NamedNodeMap nm = nd.getAttributes();
      if (nm!=null)
      {
         //There are some attributes, display them
         for(int k=0; k<nm.getLength();k++)
         {
            //Iterate over the attributes, getLength will have found them
            Node currAttribute = nm.item(k);
            //Get the name of an attribute
            String attributeName = currAttribute.getNodeName();
            //Get the value of the attribute
            String attributeValue = currAttribute.getNodeValue();
            System.out.println(" Attribute name = "+  attributeName +
                              " Attribute value = "+ attributeValue);
         }
      }

      //Get all the child nodes
      NodeList nl = nd.getChildNodes();
      //If there are any child nodes iterate over them
      //executing displayXML again
      if(nl!=null)
      {
         for(int j = 0; j<nl.getLength();j++)
            displayXML(nl.item(j));
      }
   }

   if(nd.CDATA_SECTION_NODE==nodeVal)
   {
      //Do nothing
   }

   if(nd.TEXT_NODE==nodeVal)
   {
      //Text encountered
      if (!nd.getNodeValue().equals("\n"))
         System.out.println(nd.getNodeValue());
   }

   if(nd.PROCESSING_INSTRUCTION_NODE==nodeVal)
   {
      //Do nothing
   }

}

public static void main(String[] args)
{
   try
   {
      //Set up and start the parser
      String file = "catalogue.txt";
      InputStream inStream = new FileInputStream(file);
      Parser dp = new Parser(file);
      Document doc = dp.readStream(inStream);
      //Execute displayXML to display the source of the XML
      displayXML(doc);
      System.out.println("There were " + dp.getNumberOfErrors()+" Errors");
   }
   catch(Exception e)
      {System.out.print("Problem with XML processor"+e);}
}

}