package xmlprocessor;

import org.xml.sax.*;

public class BookValues extends HandlerBase{

public BookValues()
{
}

public static void main(String[] args)
{
   try
   {
      //*************************************************************************
      // Ignore the code to the next line of asterisks: it just sets up the XML
      // parser and processes the XML contained in the file catalogue.txt
      Class loadedClass = Class.forName("com.ibm.xml.parser.SAXDriver");
      Parser xParser = (Parser)loadedClass.newInstance();
      BookValues bv = new BookValues();
      xParser.setDocumentHandler(bv);
      xParser.setErrorHandler(bv);
      xParser.parse("catalogue.txt");
   }
   catch(Exception e)
      {System.out.println("Problem starting XML processor "+e.getMessage());}
  }

      //*************************************************************************

public void error(SAXParseException se)
{
   //Executed when a serious error occurs in processing the XML source
   System.out.println("Error: Problem with XML "+se.getMessage());
}

public void warning(SAXParseException se)
{
   //Executed when a minor problem occurs when processing the XML source
   System.out.println("Warning: Problem with XML "+se.getMessage());
}

public void startDocument() throws SAXException
{
   //Executed when the XML document is executed
   System.out.println("Document started");
}

public void startElement(String elementName, AttributeList al) throws SAXException
{
   //Executed when a start element such as <TITLE> is encountered
   //elementName contains the name of the element and al contains
   //a list of the attributes
   String attributeName, attributeValue;
   System.out.println("Start ELEMENT = "+ elementName);
   if(al.getLength()>0)
      //The element has a number of attributes, for example PRICE
      System.out.println("Attributes are ");
   for(int j = 0;j<al.getLength();j++)
   {
      // List the attributes the method getName returns the name of the
      //for example AMOUNTCURENCY and amountValue returns with the valye
      //of the attribute, for example "Dollars"
      attributeName = al.getName(j);
      attributeValue = al.getValue(j);
      System.out.println("Attribute name is " + attributeName+
                         " Attribute value is " + attributeValue);
   }
}

public void endElement(String elementName) throws SAXException
{
   //Executed when the end element is encountered, for example </PUBLISHER>
   System.out.println("End ELEMENT = "+ elementName);
}

public void endDocument() throws SAXException
{
   //Executed when the XML source has been completely processed
   System.out.println("Document finished");
}

public void characters(char[] chars, int start, int length)throws SAXException
{
   //Executed when a string is encountered, for example the name of an author
   System.out.println("String read is " + new String(chars, start, length));
}



}