package nameserver;

import java.util.Hashtable;
import java.rmi.server.*;
import java.rmi.*;


//Implementation of LookupService
public class LookupServiceImpl extends UnicastRemoteObject implements LookupService{

private Hashtable server;

public LookupServiceImpl() throws RemoteException{


	
   server = new Hashtable();
}


public void populate()
{
   //Set up name value pairs, usually done with some more
   //sophisticated mechanism such as a relational database
   server.put("123.3.2.1", "Mercury");
   server.put("101.23.45.100", "Apollo");
   server.put("109.33.33.100", "Saturn");
}

public String getName(String ipAddress) throws RemoteException
{
   return (String) server.get(ipAddress);
}

public static void main(String[] args)
{
   //Load in the security manager
   System.setSecurityManager(new RMISecurityManager());
   try
   {
      //Set up the remote
      LookupServiceImpl obj = new LookupServiceImpl();
      //Populate the naming service database
      System.out.println("Naming object set up...");
      obj.populate();
      System.out.println("Naming object populated...");
      //Give the name "Lookup" to the object
      Naming.rebind("Lookup", obj);
      System.out.println("Naming object ready...");
   }
   catch(Exception e)
         {System.out.println("Problem with server"+e);}
}

}