package objectfactory;

import java.rmi.*;
import java.rmi.server.*;

public class RMIFactoryImpl extends UnicastRemoteObject implements RMIFactory{

private static RMIFactoryImpl single = null;
private static int objectCount = 0;


private RMIFactoryImpl() throws RemoteException
{
}

public  RMIFactoryImpl getFactory() throws RemoteException
{
   //Have we already created a factory object?
   if (single ==null)
      //No create one
      return new RMIFactoryImpl();
   else
      //Yes, return the created factory
   return single;
}

public StringObject createObject()throws RemoteException
{
   //Create an object
   objectCount++;
   //objectCount uniqely identifies the remote object
   return new StringObject(objectCount);
}


public static void main(String[] args)
{
    System.setSecurityManager(new RMISecurityManager());
    try
    {
       //Set up the remote object
       RMIFactoryImpl fact = new RMIFactoryImpl();
       System.out.println("Factory object set up...");
       //Factory object is named, register it with the RMI registry
       Naming.rebind("Factory",fact);
       System.out.println("Object named...");
       System.out.println("Object ready...");
    }
    catch(Exception e){System.out.println("Problem setting up factory"+e);};
  }

}